pragma solidity ^0.4.24;

import "@abacusprotocol/protocol/contracts/protocol/AnnotationDatabase.sol";
import "@abacusprotocol/protocol/contracts/protocol/ProviderRegistry.sol";
import "@abacusprotocol/protocol/contracts/library/provider/Provider.sol";
import "openzeppelin-solidity/contracts/lifecycle/Pausable.sol";
import "./SupervisedToken.sol";

contract Supervisor is Provider, Pausable {

    AnnotationDatabase annotationDatabase;

    constructor(
        AnnotationDatabase _annotationDatabase,
        ProviderRegistry _providerRegistry
    ) Provider(_providerRegistry, 0) public {
        annotationDatabase = _annotationDatabase;
    }

    event GenerateToken(
        address indexed token,
        address indexed owner,
        uint256 id
    );

    function generateToken(SupervisedToken _token, address _owner) public onlyRole(ROLE_ADMIN) {
        uint256 id = _token.mintTo(_owner);
        emit GenerateToken({
            token: _token,
            owner: _owner,
            id: id
        });
    }

    function writeCommitment(
        address _token, uint256 _tokenId, uint256 _fieldId, bytes32 _commitmentHash
    ) public onlyRole(ROLE_ADMIN) {
        annotationDatabase.writeBytes32Field(
            _token,
            _tokenId,
            providerId,
            _fieldId,
            _commitmentHash
        );
    }

}